"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPRBProxyRegistry = exports.getPRBProxyFactory = exports.getPRBProxy = void 0;
const constants_1 = require("./constants");
const PRBProxy__factory_1 = require("./types/factories/PRBProxy__factory");
const PRBProxyFactory__factory_1 = require("./types/factories/PRBProxyFactory__factory");
const PRBProxyRegistry__factory_1 = require("./types/factories/PRBProxyRegistry__factory");
function getPRBProxy(address, signerOrProvider) {
    const proxy = PRBProxy__factory_1.PRBProxy__factory.connect(address, signerOrProvider);
    return proxy;
}
exports.getPRBProxy = getPRBProxy;
function getPRBProxyFactory(signerOrProvider) {
    const factory = PRBProxyFactory__factory_1.PRBProxyFactory__factory.connect(constants_1.PRB_PROXY_FACTORY_ADDRESS, signerOrProvider);
    return factory;
}
exports.getPRBProxyFactory = getPRBProxyFactory;
function getPRBProxyRegistry(signerOrProvider) {
    const registry = PRBProxyRegistry__factory_1.PRBProxyRegistry__factory.connect(constants_1.PRB_PROXY_REGISTRY_ADDRESS, signerOrProvider);
    return registry;
}
exports.getPRBProxyRegistry = getPRBProxyRegistry;
//# sourceMappingURL=contracts.js.map