"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IPRBProxyFactory__factory = void 0;
const ethers_1 = require("ethers");
const _abi = [
    {
        anonymous: false,
        inputs: [
            {
                indexed: true,
                internalType: "address",
                name: "origin",
                type: "address",
            },
            {
                indexed: true,
                internalType: "address",
                name: "deployer",
                type: "address",
            },
            {
                indexed: true,
                internalType: "address",
                name: "owner",
                type: "address",
            },
            {
                indexed: false,
                internalType: "bytes32",
                name: "seed",
                type: "bytes32",
            },
            {
                indexed: false,
                internalType: "bytes32",
                name: "salt",
                type: "bytes32",
            },
            {
                indexed: false,
                internalType: "address",
                name: "proxy",
                type: "address",
            },
        ],
        name: "DeployProxy",
        type: "event",
    },
    {
        inputs: [],
        name: "deploy",
        outputs: [
            {
                internalType: "address payable",
                name: "proxy",
                type: "address",
            },
        ],
        stateMutability: "nonpayable",
        type: "function",
    },
    {
        inputs: [
            {
                internalType: "address",
                name: "owner",
                type: "address",
            },
        ],
        name: "deployFor",
        outputs: [
            {
                internalType: "address payable",
                name: "proxy",
                type: "address",
            },
        ],
        stateMutability: "nonpayable",
        type: "function",
    },
    {
        inputs: [
            {
                internalType: "address",
                name: "eoa",
                type: "address",
            },
        ],
        name: "getNextSeed",
        outputs: [
            {
                internalType: "bytes32",
                name: "result",
                type: "bytes32",
            },
        ],
        stateMutability: "view",
        type: "function",
    },
    {
        inputs: [
            {
                internalType: "address",
                name: "proxy",
                type: "address",
            },
        ],
        name: "isProxy",
        outputs: [
            {
                internalType: "bool",
                name: "result",
                type: "bool",
            },
        ],
        stateMutability: "view",
        type: "function",
    },
    {
        inputs: [],
        name: "version",
        outputs: [
            {
                internalType: "uint256",
                name: "",
                type: "uint256",
            },
        ],
        stateMutability: "view",
        type: "function",
    },
];
class IPRBProxyFactory__factory {
    static createInterface() {
        return new ethers_1.utils.Interface(_abi);
    }
    static connect(address, signerOrProvider) {
        return new ethers_1.Contract(address, _abi, signerOrProvider);
    }
}
exports.IPRBProxyFactory__factory = IPRBProxyFactory__factory;
IPRBProxyFactory__factory.abi = _abi;
//# sourceMappingURL=IPRBProxyFactory__factory.js.map