"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IPRBProxyRegistry__factory = void 0;
const ethers_1 = require("ethers");
const _abi = [
    {
        inputs: [],
        name: "deploy",
        outputs: [
            {
                internalType: "address payable",
                name: "proxy",
                type: "address",
            },
        ],
        stateMutability: "nonpayable",
        type: "function",
    },
    {
        inputs: [
            {
                internalType: "address",
                name: "owner",
                type: "address",
            },
        ],
        name: "deployFor",
        outputs: [
            {
                internalType: "address payable",
                name: "proxy",
                type: "address",
            },
        ],
        stateMutability: "nonpayable",
        type: "function",
    },
    {
        inputs: [],
        name: "factory",
        outputs: [
            {
                internalType: "contract IPRBProxyFactory",
                name: "proxyFactory",
                type: "address",
            },
        ],
        stateMutability: "view",
        type: "function",
    },
    {
        inputs: [
            {
                internalType: "address",
                name: "owner",
                type: "address",
            },
        ],
        name: "getCurrentProxy",
        outputs: [
            {
                internalType: "contract IPRBProxy",
                name: "proxy",
                type: "address",
            },
        ],
        stateMutability: "view",
        type: "function",
    },
];
class IPRBProxyRegistry__factory {
    static createInterface() {
        return new ethers_1.utils.Interface(_abi);
    }
    static connect(address, signerOrProvider) {
        return new ethers_1.Contract(address, _abi, signerOrProvider);
    }
}
exports.IPRBProxyRegistry__factory = IPRBProxyRegistry__factory;
IPRBProxyRegistry__factory.abi = _abi;
//# sourceMappingURL=IPRBProxyRegistry__factory.js.map